natureMod = ...

function registerBuildingPart(prefabName, name)
    natureMod:register({
        DataType = "BUILDING_PART",
        Id = MOD_NS .. name .. "_PART",
        Name = name,
        ConstructionVisual = prefabName,
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = prefabName
        },
        DesirabilityModifiers = {
            {
                    Desirability = "DESIRABILITY_RESIDENTIAL",
                    Radius = 7,
                    Value = 0.2
            }
        },
    })
end

function registerBuildingPart_NoDesirability(prefabName, name)
    natureMod:register({
        DataType = "BUILDING_PART",
        Id = MOD_NS .. name .. "_PART",
        Name = name,
        ConstructionVisual = prefabName,
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = prefabName
        }
    })
end

registerBuildingPart(MOD_NS .. "PREFAB_OAK_A", "OAK_A")
registerBuildingPart(MOD_NS .. "PREFAB_OAK_B", "OAK_B")
registerBuildingPart(MOD_NS .. "PREFAB_OAK_C", "OAK_C")
registerBuildingPart(MOD_NS .. "PREFAB_BEECH_A", "BEECH_A")
registerBuildingPart(MOD_NS .. "PREFAB_BEECH_B", "BEECH_B")
registerBuildingPart(MOD_NS .. "PREFAB_BEECH_C", "BEECH_C")
registerBuildingPart(MOD_NS .. "PREFAB_BEECH_D", "BEECH_D")
registerBuildingPart(MOD_NS .. "PREFAB_BEECH_SAPLING_A", "BEECH_SAPLING_A")
registerBuildingPart(MOD_NS .. "PREFAB_MAPLE_A", "MAPLE_A")
registerBuildingPart(MOD_NS .. "PREFAB_MAPLE_B", "MAPLE_B")
registerBuildingPart(MOD_NS .. "PREFAB_PINE_A", "PINE_A")
registerBuildingPart(MOD_NS .. "PREFAB_PINE_B", "PINE_B")
registerBuildingPart(MOD_NS .. "PREFAB_PINE_C", "PINE_C")
registerBuildingPart(MOD_NS .. "PREFAB_BIRCH_A", "BIRCH_A")
registerBuildingPart(MOD_NS .. "PREFAB_BIRCH_B", "BIRCH_B")
registerBuildingPart(MOD_NS .. "PREFAB_BIRCH_C", "BIRCH_C")

registerBuildingPart(MOD_NS .. "PREFAB_TREES_PINE_A", "TREES_PINE_A")
registerBuildingPart(MOD_NS .. "PREFAB_TREES_OAK_A", "TREES_OAK_A")

registerBuildingPart(MOD_NS .. "PREFAB_SHRUB_A", "SHRUB_A")
registerBuildingPart(MOD_NS .. "PREFAB_SHRUB_FERN", "SHRUB_FERN")
registerBuildingPart(MOD_NS .. "PREFAB_SHRUB_LAVENDER", "SHRUB_LAVENDER")
registerBuildingPart(MOD_NS .. "PREFAB_SHRUB_FORSYTHIA", "SHRUB_FORSYTHIA")
registerBuildingPart(MOD_NS .. "PREFAB_SHRUB_STEPHANANDRA", "SHRUB_STEPHANANDRA")

registerBuildingPart(MOD_NS .. "PREFAB_FLOWER_CHAMOMILE", "FLOWER_CHAMOMILE")
registerBuildingPart(MOD_NS .. "PREFAB_FLOWER_POPPIES", "FLOWER_POPPIES")
registerBuildingPart(MOD_NS .. "PREFAB_FLOWER_CORNFLOWER", "FLOWER_CORNFLOWER")

registerBuildingPart(MOD_NS .. "PREFAB_MUSHROOM", "MUSHROOM")
registerBuildingPart(MOD_NS .. "PREFAB_BERRY_BUSH", "BERRY_BUSH")

registerBuildingPart_NoDesirability(MOD_NS .. "PREFAB_REEDS", "REEDS")

natureMod:registerAssetId("models/pine.fbx/Prefab/Miniature", MOD_NS .. "TEMPERATE_BIOME_MONUMENT_MINIATURE_PREFAB")
natureMod:register({
    DataType = "BUILDING_PART",
    Id = MOD_NS .. "BIOME_MONUMENT_MINIATURE_PART",
    ConstructionVisual = MOD_NS .. "TEMPERATE_BIOME_MONUMENT_MINIATURE_PREFAB",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = MOD_NS .. "TEMPERATE_BIOME_MONUMENT_MINIATURE_PREFAB",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = -5,
            CameraPosition = { 0, 6, -34 },
            OrientationOffset = 0,
            CameraPitchOffset = 5
        },
    }
})

natureMod:register({
	DataType = "BUILDING",
	Id = MOD_NS .. "TEMPERATE_BIOME",
	Name = "FANCY_TEMPERATE_BIOME_NAME",
    Description = "FANCY_TEMPERATE_BIOME_NAME_DESC",
    AssetMiniatureBuildingPart = MOD_NS .. "BIOME_MONUMENT_MINIATURE_PART",
	BuildingType = BUILDING_TYPE.DECORATION,
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
        {
            Name = "TREES",
            BuildingPartList = {
                MOD_NS .. "OAK_A_PART", MOD_NS .. "OAK_B_PART", MOD_NS .. "OAK_C_PART", MOD_NS .. "TREES_OAK_A_PART",
                MOD_NS .. "BEECH_A_PART", MOD_NS .. "BEECH_B_PART", MOD_NS .. "BEECH_C_PART", MOD_NS .. "BEECH_D_PART",
                MOD_NS .. "BEECH_SAPLING_A_PART", MOD_NS .. "MAPLE_A_PART", MOD_NS .. "MAPLE_B_PART",
                MOD_NS .. "BIRCH_A_PART", MOD_NS .. "BIRCH_B_PART", MOD_NS .. "BIRCH_C_PART",
                MOD_NS .. "PINE_A_PART", MOD_NS .. "PINE_B_PART", MOD_NS .. "PINE_C_PART", MOD_NS .. "TREES_PINE_A_PART",
            }
        },
        {
            Name = "SHRUBS",
            BuildingPartList = {
                MOD_NS .. "BERRY_BUSH_PART",
                MOD_NS .. "SHRUB_A_PART", MOD_NS .. "SHRUB_FERN_PART", MOD_NS .. "SHRUB_LAVENDER_PART",
                MOD_NS .. "SHRUB_FORSYTHIA_PART", MOD_NS .. "SHRUB_STEPHANANDRA_PART",
            }
        },
        {
            Name = "FLOWERS",
            BuildingPartList = {
                MOD_NS .. "FLOWER_POPPIES_PART", MOD_NS .. "FLOWER_CHAMOMILE_PART", MOD_NS .. "FLOWER_CORNFLOWER_PART",
            }
        },
        {
            Name = "OTHERS",
            BuildingPartList = {
                MOD_NS .. "MUSHROOM_PART", MOD_NS .. "REEDS_PART"
            }
        },
    }
})